OGRE-Next: Ogre::v1::D3D11HardwareIndexBuffer Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Ogre::v1::D3D11HardwareIndexBuffer Class Referencefinal

`#include <OgreD3D11HardwareIndexBuffer.h>`

Inheritance diagram for Ogre::v1::D3D11HardwareIndexBuffer:
[legend]

## Public Member Functions
| D3D11HardwareIndexBuffer (HardwareBufferManagerBase *mgr, IndexType idxType, size_t numIndexes, HardwareBuffer::Usage usage, D3D11Device &device, bool useSystemMem, bool useShadowBuffer)
| ~D3D11HardwareIndexBuffer () override
void | copyData (HardwareBuffer &srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false) override
| Copy data from another buffer into this one.
ID3D11Buffer * | getD3DIndexBuffer () const
| Get the D3D-specific index buffer.
bool | isLocked () const
void * | lock (size_t offset, size_t length, LockOptions options) override
| Lock the buffer for (potentially) reading / writing.
void | readData (size_t offset, size_t length, void *pDest) override
| Reads data from the buffer and places it in the memory pointed to by pDest.
void | unlock () override
| Releases the lock on this buffer.
void | writeData (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false) override
| Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.
Public Member Functions inherited from Ogre::v1::HardwareIndexBuffer
| HardwareIndexBuffer (HardwareBufferManagerBase *mgr, IndexType idxType, size_t numIndexes, HardwareBuffer::Usage usage, bool useSystemMemory, bool useShadowBuffer)
| Should be called by HardwareBufferManager.
| ~HardwareIndexBuffer ()
size_t | getIndexSize () const
| Get the size in bytes of each index.
HardwareBufferManagerBase * | getManager () const
| Return the manager of this buffer, if any.
size_t | getNumIndexes () const
| Get the number of indexes in this buffer.
IndexType | getType () const
| Get the type of indexes used in this buffer.
Public Member Functions inherited from Ogre::v1::HardwareBuffer
| HardwareBuffer (Usage usage, bool systemMemory, bool useShadowBuffer)
| Constructor, to be called by HardwareBufferManager only.
virtual | ~HardwareBuffer ()
virtual void | _updateFromShadow ()
| Updates the real buffer from the shadow buffer, if required.
virtual void | copyData (HardwareBuffer &srcBuffer)
| Copy all data from another buffer into this one.
virtual void * | getRenderSystemData ()
| An internal function that should be used only by a render system for internal use.
size_t | getSizeInBytes () const
| Returns the size of this buffer in bytes.
Usage | getUsage () const
| Returns the Usage flags with which this buffer was created.
bool | hasShadowBuffer () const
| Returns whether this buffer has a system memory shadow for quicker reading.
bool | isLocked () const
| Returns whether or not this buffer is currently locked.
bool | isSystemMemory () const
| Returns whether this buffer is held in system memory.
void * | lock (LockOptions options)
| Lock the entire buffer for (potentially) reading / writing.
void | suppressHardwareUpdate (bool suppress)
| Pass true to suppress hardware upload of shadow buffer changes.

## Additional Inherited Members
Public Types inherited from Ogre::v1::HardwareIndexBuffer
typedef Ogre::IndexType | IndexType
Public Types inherited from Ogre::v1::HardwareBuffer
enum | LockOptions { HBL_NORMAL , HBL_DISCARD , HBL_READ_ONLY , HBL_NO_OVERWRITE , HBL_WRITE_ONLY }
| Locking options. More...
enum | Usage { HBU_STATIC = 1 , HBU_DYNAMIC = 2 , HBU_WRITE_ONLY = 4 , HBU_DISCARDABLE = 8 , HBU_STATIC_WRITE_ONLY = 5 , HBU_DYNAMIC_WRITE_ONLY = 6 , HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = 14 }
| Enums describing buffer usage; not mutually exclusive. More...
Static Public Attributes inherited from Ogre::v1::HardwareIndexBuffer
static const IndexType | IT_16BIT = Ogre::IT_16BIT
static const IndexType | IT_32BIT = Ogre::IT_32BIT

## Constructor & Destructor Documentation

## ◆ D3D11HardwareIndexBuffer()

Ogre::v1::D3D11HardwareIndexBuffer::D3D11HardwareIndexBuffer | ( | HardwareBufferManagerBase * | mgr,
|  | IndexType | idxType,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage,
|  | D3D11Device & | device,
|  | bool | useSystemMem,
|  | bool | useShadowBuffer )

## ◆ ~D3D11HardwareIndexBuffer()

Ogre::v1::D3D11HardwareIndexBuffer::~D3D11HardwareIndexBuffer | ( |  | ) |
| override

## Member Function Documentation

## ◆ copyData()

void Ogre::v1::D3D11HardwareIndexBuffer::copyData | ( | HardwareBuffer & | srcBuffer,
|  | size_t | srcOffset,
|  | size_t | dstOffset,
|  | size_t | length,
|  | bool | discardWholeBuffer = false )
| overridevirtual

Copy data from another buffer into this one.

Remarks
  Note that the source buffer must not be created with the usage HBU_WRITE_ONLY otherwise this will fail.

Parameters

  srcBuffer | The buffer from which to read the copied data
  srcOffset | Offset in the source buffer at which to start reading
  dstOffset | Offset in the destination buffer to start writing
  length | Length of the data to copy, in bytes.
  discardWholeBuffer | If true, will discard the entire contents of this buffer before copying

Reimplemented from Ogre::v1::HardwareBuffer.

## ◆ getD3DIndexBuffer()

ID3D11Buffer * Ogre::v1::D3D11HardwareIndexBuffer::getD3DIndexBuffer | ( |  | ) | const

Get the D3D-specific index buffer.

## ◆ isLocked()

bool Ogre::v1::D3D11HardwareIndexBuffer::isLocked | ( |  | ) | const

## ◆ lock()

void * Ogre::v1::D3D11HardwareIndexBuffer::lock | ( | size_t | offset,
|  | size_t | length,
|  | LockOptions | options )
| overridevirtual

Lock the buffer for (potentially) reading / writing.

Parameters

  offset | The byte offset from the start of the buffer to lock
  length | The size of the area to lock, in bytes
  options | Locking options

Returns
  Pointer to the locked memory

Reimplemented from Ogre::v1::HardwareBuffer.

## ◆ readData()

void Ogre::v1::D3D11HardwareIndexBuffer::readData | ( | size_t | offset,
|  | size_t | length,
|  | void * | pDest )
| overridevirtual

Reads data from the buffer and places it in the memory pointed to by pDest.

Parameters

  offset | The byte offset from the start of the buffer to read
  length | The size of the area to read, in bytes
  pDest | The area of memory in which to place the data, must be large enough to accommodate the data!

Implements Ogre::v1::HardwareBuffer.

## ◆ unlock()

void Ogre::v1::D3D11HardwareIndexBuffer::unlock | ( |  | ) |
| overridevirtual

Releases the lock on this buffer.

Remarks
  Locking and unlocking a buffer can, in some rare circumstances such as switching video modes whilst the buffer is locked, corrupt the contents of a buffer. This is pretty rare, but if it occurs, this method will throw an exception, meaning you must re-upload the data.

  Note that using the 'read' and 'write' forms of updating the buffer does not suffer from this problem, so if you want to be 100% sure your data will not be lost, use the 'read' and 'write' forms instead.

Reimplemented from Ogre::v1::HardwareBuffer.

## ◆ writeData()

void Ogre::v1::D3D11HardwareIndexBuffer::writeData | ( | size_t | offset,
|  | size_t | length,
|  | const void * | pSource,
|  | bool | discardWholeBuffer = false )
| overridevirtual

Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.

Parameters

  offset | The byte offset from the start of the buffer to start writing
  length | The size of the data to write to, in bytes
  pSource | The source of the data to be written
  discardWholeBuffer | If true, this allows the driver to discard the entire buffer when writing, such that DMA stalls can be avoided; use if you can.

Implements Ogre::v1::HardwareBuffer.

The documentation for this class was generated from the following file:

- OgreD3D11HardwareIndexBuffer.h